# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class ContentSource(Model):
    """Definition of the content source.

    :param hash: Gets or sets the hash.
    :type hash: ~azure.mgmt.automation.models.ContentHash
    :param type: Gets or sets the content source type. Possible values
     include: 'embeddedContent', 'uri'
    :type type: str or ~azure.mgmt.automation.models.ContentSourceType
    :param value: Gets or sets the value of the content. This is based on the
     content source type.
    :type value: str
    :param version: Gets or sets the version of the content.
    :type version: str
    """

    _attribute_map = {
        'hash': {'key': 'hash', 'type': 'ContentHash'},
        'type': {'key': 'type', 'type': 'str'},
        'value': {'key': 'value', 'type': 'str'},
        'version': {'key': 'version', 'type': 'str'},
    }

    def __init__(self, **kwargs):
        super(ContentSource, self).__init__(**kwargs)
        self.hash = kwargs.get('hash', None)
        self.type = kwargs.get('type', None)
        self.value = kwargs.get('value', None)
        self.version = kwargs.get('version', None)
